/* -*- mode: c++ -*- */
#ifndef __pydaqpp_Buffer_h__
#define __pydaqpp_Buffer_h__
#include <Python.h>
struct daqpp_buffer;

#if (PY_VERSION_HEX < 0x02050000)
typedef int Py_ssize_t;
#endif

/**
 * This is a buffer object that will be used to transfer the data
 * from the C++ side to Python. It is very much like the array object
 * in the Pyton library
 */
struct daqpp_buffer_descriptor
{
    int type;
    int size;
    PyObject * (*getitem)(struct daqpp_buffer *, Py_ssize_t);
    int (*setitem)(struct daqpp_buffer *, Py_ssize_t, PyObject *);
};

typedef struct daqpp_buffer
{
    PyObject_HEAD
    /* Type-specific fields go here. */
    int own;
    Py_ssize_t nitems;
    Py_ssize_t len;
    char *item;
    struct daqpp_buffer_descriptor *descr;
    PyObject *weakreflist; /* List of weak references */
    PyObject *cobj; /* a CObject keeping the memory alive */
    PyObject    *dict;
} daqpp_buffer;

#endif
