/* soapdaqppSOAPService.h
   Generated by gSOAP 2.8.17r from /Users/lacasta/workspace/daqpp/DAQ++/soap/daqpp.h

Copyright(C) 2000-2013, Robert van Engelen, Genivia Inc. All Rights Reserved.
The generated code is released under one of the following licenses:
GPL or Genivia's license for commercial use.
This program is released under the GPL with the additional exemption that
compiling, linking, and/or using OpenSSL is allowed.
*/

#ifndef soapdaqppSOAPService_H
#define soapdaqppSOAPService_H
#include "soapH.h"
class SOAP_CMAC daqppSOAPService : public soap
{ public:
	/// Constructor
	daqppSOAPService();
	/// Construct from another engine state
	daqppSOAPService(const struct soap&);
	/// Constructor with engine input+output mode control
	daqppSOAPService(soap_mode iomode);
	/// Constructor with engine input and output mode control
	daqppSOAPService(soap_mode imode, soap_mode omode);
	/// Destructor, also frees all deserialized data
	virtual ~daqppSOAPService();
	/// Delete all deserialized data (with soap_destroy and soap_end)
	virtual	void destroy();
	/// Delete all deserialized data and reset to defaults
	virtual	void reset();
	/// Initializer used by constructor
	virtual	void daqppSOAPService_init(soap_mode imode, soap_mode omode);
	/// Create a copy
	virtual	daqppSOAPService *copy() SOAP_PURE_VIRTUAL;
	/// Close connection (normally automatic)
	virtual	int soap_close_socket();
	/// Force close connection (can kill a thread blocked on IO)
	virtual	int soap_force_close_socket();
	/// Return sender-related fault to sender
	virtual	int soap_senderfault(const char *string, const char *detailXML);
	/// Return sender-related fault with SOAP 1.2 subcode to sender
	virtual	int soap_senderfault(const char *subcodeQName, const char *string, const char *detailXML);
	/// Return receiver-related fault to sender
	virtual	int soap_receiverfault(const char *string, const char *detailXML);
	/// Return receiver-related fault with SOAP 1.2 subcode to sender
	virtual	int soap_receiverfault(const char *subcodeQName, const char *string, const char *detailXML);
	/// Print fault
	virtual	void soap_print_fault(FILE*);
#ifndef WITH_LEAN
	/// Print fault to stream
#ifndef WITH_COMPAT
	virtual	void soap_stream_fault(std::ostream&);
#endif
	/// Put fault into buffer
	virtual	char *soap_sprint_fault(char *buf, size_t len);
#endif
	/// Disables and removes SOAP Header from message
	virtual	void soap_noheader();
	/// Get SOAP Header structure (NULL when absent)
	virtual	const SOAP_ENV__Header *soap_header();
	/// Run simple single-thread iterative service on port until a connection error occurs (returns error code or SOAP_OK), use this->bind_flag = SO_REUSEADDR to rebind for a rerun
	virtual	int run(int port);
	/// Bind service to port (returns master socket or SOAP_INVALID_SOCKET)
	virtual	SOAP_SOCKET bind(const char *host, int port, int backlog);
	/// Accept next request (returns socket or SOAP_INVALID_SOCKET)
	virtual	SOAP_SOCKET accept();
#if defined(WITH_OPENSSL) || defined(WITH_GNUTLS)
	/// Then accept SSL handshake, when SSL is used
	virtual	int ssl_accept();
#endif
	/// Serve this request (returns error code or SOAP_OK)
	virtual	int serve();
	/// Used by serve() to dispatch a request (returns error code or SOAP_OK)
	virtual	int dispatch();

	///
	/// Service operations (you should define these):
	/// Note: compile with -DWITH_PURE_VIRTUAL for pure virtual methods
	///

	/// Web service operation 'getModuleList' (returns error code or SOAP_OK)
	virtual	int getModuleList(int getModuleListRequest, struct ns1__getModuleListResponse &_param_1) SOAP_PURE_VIRTUAL;

	/// Web service operation 'getRunManagerList' (returns error code or SOAP_OK)
	virtual	int getRunManagerList(int getRunManagerListRequest, struct ns1__getRunManagerListResponse &_param_2) SOAP_PURE_VIRTUAL;

	/// Web service operation 'getParameterNames' (returns error code or SOAP_OK)
	virtual	int getParameterNames(std::string daqid, struct ns1__getParameterNamesResponse &_param_3) SOAP_PURE_VIRTUAL;

	/// Web service operation 'getStatus' (returns error code or SOAP_OK)
	virtual	int getStatus(std::string daqid, struct ns1__getStatusResponse &_param_4) SOAP_PURE_VIRTUAL;

	/// Web service operation 'getParameter' (returns error code or SOAP_OK)
	virtual	int getParameter(ns1__ParameterID *parID, struct ns1__getParameterResponse &_param_5) SOAP_PURE_VIRTUAL;

	/// Web service operation 'setParameter' (returns error code or SOAP_OK)
	virtual	int setParameter(ns1__Parameter *param, int &setParameterResponse) SOAP_PURE_VIRTUAL;

	/// Web service operation 'activateRunManager' (returns error code or SOAP_OK)
	virtual	int activateRunManager(std::string daqid, int &activateRMResponse) SOAP_PURE_VIRTUAL;

	/// Web service operation 'StartRunManager' (returns error code or SOAP_OK)
	virtual	int StartRunManager(std::string daqid, int &StartRunManagerResponse) SOAP_PURE_VIRTUAL;

	/// Web service operation 'StopRunManager' (returns error code or SOAP_OK)
	virtual	int StopRunManager(std::string daqid, int &StopRunManagerResponse) SOAP_PURE_VIRTUAL;

	/// Web service operation 'GetReady' (returns error code or SOAP_OK)
	virtual	int GetReady(std::string daqid, int &GetReadyResponse) SOAP_PURE_VIRTUAL;

	/// Web service operation 'Pause' (returns error code or SOAP_OK)
	virtual	int Pause(std::string daqid, int &PauseResponse) SOAP_PURE_VIRTUAL;

	/// Web service operation 'Continue' (returns error code or SOAP_OK)
	virtual	int Continue(std::string daqid, int &ContinueResponse) SOAP_PURE_VIRTUAL;

	/// Web service operation 'Reset' (returns error code or SOAP_OK)
	virtual	int Reset(std::string daqid, int &ResetResponse) SOAP_PURE_VIRTUAL;

	/// Web service operation 'setMaxEvents' (returns error code or SOAP_OK)
	virtual	int setMaxEvents(ns1__MaxEvents *maxEvents, int &setMaxEventsResponse) SOAP_PURE_VIRTUAL;

	/// Web service operation 'getMonitorData' (returns error code or SOAP_OK)
	virtual	int getMonitorData(std::string daqid, xsd__base64Binary &getMonitorDataResponse) SOAP_PURE_VIRTUAL;

	/// Web service operation 'stopServer' (returns error code or SOAP_OK)
	virtual	int stopServer(int stopServerRequest, int &stopServerResponse) SOAP_PURE_VIRTUAL;

	/// Web service operation 'resetMonitorData' (returns error code or SOAP_OK)
	virtual	int resetMonitorData(std::string daqid, int &resetMonitorDataResponse) SOAP_PURE_VIRTUAL;

	/// Web service operation 'sendUpdate' (returns error code or SOAP_OK)
	virtual	int sendUpdate(int sendUpdateRequest, struct ns1__sendUpdateResponse &_param_6) SOAP_PURE_VIRTUAL;

	/// Web service operation 'getRunManagerModules' (returns error code or SOAP_OK)
	virtual	int getRunManagerModules(std::string daqid, struct ns1__getRunManagerModulesResponse &_param_7) SOAP_PURE_VIRTUAL;
};
#endif
