#ifndef __PluginTypes_h__
#define __PluginTypes_h__

#include <string>

class HookType
{
    private:
        std::string _lib;
        std::string _hook;
        
        void cpy(const HookType &H)
        {
            _lib = H._lib;
            _hook = H._hook;
        }
    public:
        HookType(const std::string &L, const std::string &H):
            _lib(L), _hook(H) {}
        
        HookType(const HookType &H)
        {
            cpy(H);
        }
        
        HookType &operator=(const HookType &H)
        {
            if (&H!=this)
                cpy(H);
            return *this;
        }
        virtual ~HookType() {}
        
        std::string lib() const { return _lib; }
        std::string hook() const { return _hook; }
};

class PluginType : public HookType
{
    private:
        std::string _id;
        std::string _element;
        
        void cpy(const PluginType &P)
        {
            *((HookType *)this) = *((HookType *)&P);
            _id = P._id;
            _element = P._element;
        }
    public:
        PluginType(const std::string &id, const std::string &nam, const std::string &L, const std:.string &H):
            HookType(L,H),_id(id), _element(nam) {}
        PluginType(const PluginType &P)
        {
            cpy(P);
        }
        ~PluginType() {}
        
        std::string id() const { return _id; }
        std::string element() const { return _element; }
};


#endif /* __PluginTypes_h__*/
