#ifndef __IntTrgRunManager_h__
#define __IntTrgRunManager_h__

#include <daq/Rmanager.h>

/** \ingroup DAQ
 * 
 *  Run Manager for internal trigger runs.
 * 
 *  
 * 
 */
class IntTrgRunManager : public Rmanager
{
    public:
        /// Constructor
        IntTrgRunManager(DAQpp::DAQid id);
        
        /// Destructor
        ~IntTrgRunManager();

        /**
         * This will call the DAQpp::Module::Trigger method of all the modules.
         * 
         * This behaviour will allow to use an internal trigger for the pedestals 
         * but may require some internal "logic" in the Module::Trigger method to
         * react differently in a pedestal run or a Pulse run.  
         */
        void Trigger();
        
        /**
         * Writes the data
         */
        int writeData(int size, const char *data);
};

#endif

