#ifndef __MyUtils_Included__
#define __MyUtils_Included__
#ifdef HAVE_CONFIG_H
#include <config.h>
#endif

#include <ctime>

#if defined(HAS_GPIB)

#if HAS_GPIB == 1
#include <sys/ugpib.h>
#elif HAS_GPIB == 2
#include <ni488.h>
#elif HAS_GPIB == 3
#include <ib.h>
#endif

bool   GPIBWriteFast(int dev, const char *);
bool   GPIBReadFast(int dev, char *, int sz);
bool   GPIBRead(int dev, int delay, char *out, int sz);
bool   GPIBWrite(int dev, const char *fmt, ...);
bool   GPIBWriteRead(int dev, int delay, char *, int, const char *fmt, ...);
void   GPIBdecodestatus();
const char *GPIBstatus();
double TElapsed(time_t );

extern  std::string GPIBlastCommad;
extern int GPIB_debug;

#endif /* if defined(HAS_GPIB) */


#endif
