#ifndef __PLUGINHOOK_H_
#define __PLUGINHOOK_H_

#include <string>
#include <GladeApp.h>

class PluginHook : public GladeApp
{
    private:
        std::string _lib;
        std::string _hook;
        
        static void on_help(GtkWidget *w, PluginHook *);
        static void on_browse_lib(GtkWidget *w, PluginHook *);
        static void on_find_symbols(GtkWidget *w, PluginHook *);
        static void on_hook_selected(GtkWidget *w, PluginHook *);
    public:
        PluginHook(const std::string &L="", const std::string &H="");
        virtual ~PluginHook();
        
        void user_init();
        void auto_connect();
        void process_text(const std::string &s, GtkWidget *w);
        
        std::string lib() const { return _lib; }
        std::string hook() const { return _hook; }
};

#endif /*__PLUGINHOOK_H_*/
