#ifndef __PLUGINSETTINGS_H_
#define __PLUGINSETTINGS_H_

#include <gui/GladeApp.h>
#include <string>
#include <map>
class PluginSettings : public GladeApp
{
    private:
        GtkTreeStore *plugin_store, *rm_store, *md_store, *drv_store;
        std::map<std::string, std::string> deleted_modules, deleted_plugins;
        
        static void on_btnAdd(GtkWidget *, PluginSettings *);
        static void on_btnDelete(GtkWidget *, PluginSettings *);
        static void on_btnEdit(GtkWidget *, PluginSettings *);
        static void on_btnUp(GtkWidget *, PluginSettings *);
        static void on_btnDown(GtkWidget *, PluginSettings *);
        static void on_btnHook(GtkWidget *, PluginSettings *);
        static void on_help(GtkWidget *, PluginSettings *);
        static void on_find_hook(GtkWidget *, PluginSettings *);
        static void on_btnOK(GtkWidget *, PluginSettings *);
        
        static void on_btnBrowseInt(GtkWidget *, PluginSettings *);
        static void on_btnEnable(GtkWidget *, PluginSettings *);
        static void on_btnDisable(GtkWidget *, PluginSettings *);
        static void on_btnStart(GtkWidget *, PluginSettings *);
        static void on_btnStop(GtkWidget *, PluginSettings *);
        static void on_btnReset(GtkWidget *, PluginSettings *);
        static void on_runmanager_add(GtkWidget *, PluginSettings *);
        static void on_runmanager_remove(GtkWidget *, PluginSettings *);
        static void on_runmanager_hook(GtkWidget *, PluginSettings *ps);
        static void on_data_logger(GtkWidget *, PluginSettings *);
        static void on_module_add(GtkWidget *, PluginSettings *h);
        static void on_module_remove(GtkWidget *, PluginSettings *h);
        static void on_driver_add(GtkWidget *, PluginSettings *h);
        static void on_driver_remove(GtkWidget *, PluginSettings *h);
        static void on_driver_hook(GtkWidget *, PluginSettings *h);
        void move_row(gboolean up);
    public:
        PluginSettings();
        virtual ~PluginSettings();
        
        void user_init();
        void auto_connect();
};

#endif /*PLUGINSETTINGS_H_*/
