#ifndef __signal_gtkmessagebox_h__
#define __signal_gtkmessagebox_h__
#include <gtk/gtkdialog.h>

#ifdef __cplusplus
extern "C"
{
#endif    /* __cplusplus */
#define GTK_TYPE_MESSAGEBOX            (gtk_messagebox_get_type())
#define GTK_MESSAGEBOX(obj)            (G_TYPE_CHECK_INSTANCE_CAST ((obj),GTK_TYPE_MESSAGEBOX, GtkMessagebox))
#define GTK_MESSAGEBOX_CLASS(klass)    (G_TYPE_CHECK_CLASS_CAST ((klass),GTK_TYPE_MESSAGEBOX, GtkMessageboxClass))
#define GTK_IS_MESSAGEBOX(obj)         (G_TYPE_CHECK_INSTANCE_TYPE ((obj),GTK_TYPE_MESSAGEBOX))
#define GTK_IS_MESSAGEBOX_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), GTK_TYPE_MESSAGEBOX))
#define GTK_MESSAGEBOX_GET_CLASS(obj)  (G_TYPE_INSTANCE_GET_CLASS ((obj), GTK_TYPE_MESSAGEBOX, GtkMessageboxClass))

    typedef enum {
        MSG_BOX_NO_ICON,
        MSG_BOX_INFORMATION,
        MSG_BOX_WARNING,
        MSG_BOX_CRITICAL
    } GtkMessageboxIcon;

    typedef enum {
        MSG_BOX_NONE = 0,
        MSG_BOX_OK = 0x01,
        MSG_BOX_CANCEL = 0x02,
        MSG_BOX_YES = 0x04,
        MSG_BOX_NO = 0x08,
        MSG_BOX_ABORT = 0x10,
        MSG_BOX_RETRY = 0x20,
        MSG_BOX_IGNORE = 0x40
    } GtkMessageboxButton;



    typedef struct _GtkMessagebox GtkMessagebox;
    typedef struct _GtkMessageboxClass GtkMessageboxClass;

    struct _GtkMessagebox
    {
        GtkDialog dlg;
        int rc;
        GtkMessageboxIcon icon_type;
        unsigned long button_list;
        char *app_text;
        char *msg_text;

    };

    struct _GtkMessageboxClass
    {
        GtkDialogClass parent_class;
    };

    GType gtk_messagebox_get_type (void);
    GtkWidget *gtk_messagebox_new (const char *app, const char *msg, GtkMessageboxIcon i_type, unsigned long b_list);
    GtkMessageboxButton gtk_messagebox_exec (GtkMessagebox *);
    GtkMessageboxButton gtk_messagebox_run (GtkMessagebox *);
#ifdef __cplusplus
}
#endif    /* __cplusplus */
#endif
