#ifndef _RUNMENU_HH
#define _RUNMENU_HH

#include <gdk/gdk.h>
#include <gtk/gtkmenu.h>

G_BEGIN_DECLS

#define TYPE_RUNMENU            (runmenu_get_type())
#define RUNMENU(obj)            (G_TYPE_CHECK_INSTANCE_CAST ((obj),TYPE_RUNMENU, Runmenu))
#define RUNMENU_CLASS(klass)    (G_TYPE_CHECK_CLASS_CAST ((klass),TYPE_RUNMENU, RunmenuClass))
#define IS_RUNMENU(obj)         (G_TYPE_CHECK_INSTANCE_TYPE ((obj),TYPE_RUNMENU))
#define IS_RUNMENU_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_RUNMENU))
#define RUNMENU_GET_CLASS(obj)  (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_RUNMENU, RunmenuClass))

typedef struct _Runmenu Runmenu;
typedef struct _RunmenuClass RunmenuClass;
typedef enum {
    getready,
    run,
    stop,
    pauserun,
    resume,
    send_reset,
    gettingready
} RunStates;

struct _Runmenu
{
    GtkMenu menu;
    GtkWidget *igetready;
    GtkWidget *istartrun;
    GtkWidget *istoprun;
    GtkWidget *ipauserun;
    GtkWidget *icontinuerun;
    GtkWidget *ireset;
    GtkWidget *iquit;
    gint tmout;
    gint have_to_stop;
};

struct _RunmenuClass
{
    GtkMenuClass parent_class;
    void (*command) (Runmenu * runm);
};

GType runmenu_get_type (void);
GtkWidget *gtk_runmenu_new (void);
void gtk_runmenu_set_notready (Runmenu *);
void gtk_runmenu_set_ready (Runmenu *);
void gtk_runmenu_set_running (Runmenu *);
void gtk_runmenu_set_paused (Runmenu *);
void gtk_runmenu_stop (Runmenu *);
void gtk_runmenu_emit(Runmenu *, RunStates cmmd);

G_END_DECLS
#endif
