#ifndef BGOMODULE_ANALYSIS_H_
#define BGOMODULE_ANALYSIS_H_

#include <data/Analysis.h>
#include <list>
#include <vector>

class BGOmap;

class BGOmodule_analysis : public Analysis
{
    public:
        BGOmodule_analysis(int nchip, int nchan);
        virtual ~BGOmodule_analysis();
        
        void decode(unsigned int *data);
        void Analyze();
	std::list<int> findHits(int& iBlock);
	void SetMeshPath(std::string _mesh_path) {mesh_path=_mesh_path;}
	const std::stack<int>& get_hits() const {return hits;}
	
 private:
	std::string mesh_path;
	int id;
	Analysis *ana;
	std::vector<BGOmap *> mapList;
	int nBad;
	int iEvt;
	std::vector<double> gain;

};

#endif /*BGOMODULE_ANALYSIS_H_*/
