/* -*- mode: c++ -*- */
#ifndef __FBTDCmodule_h__
#define __FBTDCmodule_h__
#ifdef HAVE_CONFIG_H
#include <config.h>
#endif

#include <vector>
#include <daq/GenModule.h>



class FBTDCmodule : public GenModule
{
private:
    std::vector<int> thrs;
public:
    FBTDCmodule( const DAQpp::DAQid &id, unsigned long add);
    ~FBTDCmodule();

    bool hasData();
    char *getData(int &size);
    int PrepareForRun ();
    int Start (int = 0);
    int Stop (int = 0)
    {
        return 0;
    };
    int Pause ()
    {
        return 0;
    };
    int Continue ()
    {
        return 0;
    };
    int Reset ();
    int GetReady ();
    int Trigger ()
    {
        return 0;
    };
    void flush ()
    {};

    int get_thres(int x) const
    {
        return thrs[x];
    }
    std::vector<int> get_threshold() const
    {
        return thrs;
    }
    void set_threshold( const std::vector<int> &v )
    {
        thrs.clear();
        thrs = v;
    }

    unsigned long get_address() const
    {
        return _add;
    }

    void set_header_description(unsigned int &data);

    void reset_monitor_data();
    
    unsigned long get_data_type() const;
};



#endif
