#include "daq/GenModule.h"

class FPGACaenV1495;

class reconModule : public GenModule
{
 public:
  
  reconModule(const DAQpp::DAQid &id, unsigned long address);
  
  ~reconModule(){;}
  
    /** This is the method called by the RunManager to know if there
     * is data ready in the module. If the answer if true, then it
     * will try to read the module. If there is no way to know a
     * priory about the availavility of data, one can defer the
     * decision until getData
     *
     **/
    bool hasData(){return 1;}
    
    /** This is the method called to retrieve the data. If hasData
     * could not figure out hte right answer, one can still say here
     * that there is no dat aat all by returning a NULL pointer and
     * setting size to 0.
     *
     * The memory to store the data should be allocated with the
     * allocate method. See the DAQ++ documentation...
     *
     **/
    char *getData(int &size);
    
    int PrepareForRun(){return 0;}
    
    int Start(int = 0);
    
    int Stop(int = 0){return 0;}
    
    int Pause(){return 0;}
    
    int Continue(){return 0;}
    
    int Reset(){return 0;}
    
    int GetReady(){return 0;}
    
    int Trigger(){return 0;}
    
    void flush()
    {
    }
    
    /**
     * This returns the data type. The existing data types
     * can be found in DataFormat.h It is a number constructed
     * like: (n & 0xF)<<16;
     */
    unsigned long get_data_type() const
    {
      return 0x0000;
    }
    void set_scan_point(ScanPoint &);


};
