/* -*- mode: c++ -*- */
#ifndef __TDCCaen488_analysis_h__
#define __TDCCaen488_analysis_h__

#include <data/Analysis.h>
#include <data/DataFormat.h>

/**
 * This is the class that performs the analysis of the data sampled by
 * the Monitor process. This process, if enabled, will call
 * Analysis::Fill, which in turn will call
 *    Analysis::data_valid(unsigned long *data) to validate the data
 *                                              chunk
 * and, if the data is valid,
 *    Analysis::Analyze();
 *
 * Analyze expects the data already decoded and stored somehow in the
 * class. The data decoding is performed by ModuleHandler::decode and
 * that could be a good place to store the data internally in the
 * Analysis class.
 *
 * Both data_valid and Analyze are virtual methods so you can derive
 * from Analysis and overwrite those methods.
 *
 **/
class TDCCaen488_analysis : public Analysis {
   public:
      TDCCaen488_analysis() : Analysis(8,1) {}
      void Analyze();
//       void init_run();
//       void end_run();

      void decode(unsigned int *data);
};

#endif
